<?php

/**
* @author Tsixm Xephor
* @copyright 2005 Aklix Networks
* @link http://www.aklix.com/
* @package AxNet Developer's CMS
* @version 0.1.1
**/

/* ***************************************************************************
* This file is part of AxNet Developer's CMS.
* 
* AxNet Developer's CMS is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* 
* AxNet Developer's CMS is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with AxNet Developer's CMS; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*************************************************************************** */

function axClean($string)
{
	$string = stripslashes($string);
	// Added to hopefully get rid of those annoying http added slashes

	$string = str_replace("@","(pAt)",$string);
	$string = str_replace("#","(pNr)",$string);
	$string = str_replace("!","(pEx)",$string);
	$string = str_replace("$","(pDS)",$string);
	$string = str_replace("%","(pMs)",$string);
	$string = str_replace("^","(pCt)",$string);
	$string = str_replace("&","(pA)",$string);
	$string = str_replace("*","(pAx)",$string);
	$string = str_replace("-","(pDh)",$string);
	$string = str_replace("\\","(pBS)",$string);
	$string = str_replace("/","(pFS)",$string);
	$string = str_replace("_","(pUS)",$string);
	$string = str_replace("+","(pPs)",$string);
	$string = str_replace("=","(pEq)",$string);
	$string = str_replace("~","(pTd)",$string);
	$string = str_replace("`","(pBT)",$string);
	$string = str_replace("'","(pSQ)",$string);
	$string = str_replace("\"","(pDQ)",$string);
	$string = str_replace("<","(pLT)",$string);
	$string = str_replace(">","(pGT)",$string);
	$string = str_replace(",","(pCa)",$string);
	$string = str_replace(".","(pPd)",$string);
	$string = str_replace("?","(pQ)",$string);
	$string = str_replace("|","(pDv)",$string);
	$string = str_replace(":","(pC)",$string);
	$string = str_replace(";","(pSC)",$string);
	$string = str_replace("{","(pOC)",$string);
	$string = str_replace("}","(pCC)",$string);
	
	return $string;
}

function axParse($string, $mode = 0)
{
	$string = str_replace("(pBS)(pBS)",	"(pBS)", $string);
	$string = str_replace("(pBS)(pSQ)",	"(pSQ)", $string);
	$string = str_replace("(pBS)(pDQ)",	"(pDQ)", $string);
	$string = str_replace("(pAt)",       "@", $string);
	$string = str_replace("(pNr)",     	"#", $string);
	$string = str_replace("(pEx)",    	"!", $string);
	$string = str_replace("(pDS)",     	"$", $string);
	$string = str_replace("(pMs)",   	"%", $string);
	$string = str_replace("(pCt)",     	"^", $string);
	$string = str_replace("(pA)",		"&", $string);
	$string = str_replace("(pAx)",		"*", $string);
	$string = str_replace("(pDh)",		"-", $string);
	$string = str_replace("(pBS)",		"\\",$string);
	$string = str_replace("(pFS)",		"/", $string);
	$string = str_replace("(pUS)",		"_", $string);
	$string = str_replace("(pPs)",		"+", $string);
	$string = str_replace("(pEq)",		"=", $string);
	$string = str_replace("(pTd)",		"~", $string);
	$string = str_replace("(pBT)",		"`", $string);
	$string = str_replace("(pSQ)",		"'", $string);
	$string = str_replace("(pDQ)",		"\"",$string);
	$string = str_replace("(pLT)",		"&lt;", $string);
	$string = str_replace("(pGT)",		"&gt;", $string);
	$string = str_replace("(pCa)",		",", $string);
	$string = str_replace("(pPd)",		".", $string);
	$string = str_replace("(pQ)",		"?", $string);
	$string = str_replace("(pDv)",		"|", $string);
	$string = str_replace("(pC)",		":", $string);
	$string = str_replace("(pSC)",		";", $string);
	$string = str_replace("(pOC)",		"{", $string);
	$string = str_replace("(pCC)",		"}", $string);
	
	if($mode == 0){
		$string = parse_bbcode($string);
	}
	return $string;
}

// Parse ze bbcode w00t
function parse_bbcode($text)
{
	GLOBAL $lang;
	
	$text = " ".$text;
	
	$text = ereg_replace(" http://([a-zA-Z0-9./-]+)([a-zA-Z]+) ","<a href=\"\\0\">\\0</a>",$text);
	
	$text = parse_smilies($text);
	
	if (! (strpos($text, "[") && strpos($text, "]")) )
	{
		$text = nl2br($text);
		$text = ltrim($text," ");
		
		return $text;
	}
	
	// Lets replace commen formatting codes
	$text = str_replace("[b]","<span style=\"FONT-WEIGHT: bold\">",$text);
	$text = str_replace("[/b]","</span>",$text);
	$text = str_replace("[i]","<span style=\"FONT-STYLE: italic\">",$text);
	$text = str_replace("[/i]","</span>",$text);
	$text = str_replace("[u]","<span style=\"TEXT-DECORATION: underline\">",$text);
	$text = str_replace("[/u]","</span>",$text);
	
	// Cool.  Now for something a bit more tricky
	
	// Code
	$replace_code = "<table width=\"90%\" cellspacing=\"1\" cellpadding=\"3\" border=\"0\" align=\"center\"><tr><td><span class=\"gensmall\"><b>".$lang['code'].":</b></span></td></tr><tr><td class=\"code\">";
	$text = str_replace("[code]",$replace_code,$text);
	$text = str_replace("[/code]","</td></tr></table>",$text);
	
	// Quote Anonymous
	$replace_code = "<table width=\"90%\" cellspacing=\"1\" cellpadding=\"3\" border=\"0\" align=\"center\"><tr><td><span class=\"gensmall\"><b>".$lang['quote'].":</b></span></td></tr><tr><td class=\"quote\">";
	$text = str_replace("[quote]",$replace_code,$text);
	
	// Quote Author
	$text = ereg_replace("\[quote=([a-zA-Z0-9]+)\]","<table width=\"90%\" cellspacing=\"1\" cellpadding=\"3\" border=\"0\" align=\"center\"><tr><td><span class=\"gensmall\"><b>\\1 ".$lang['wrote'].":</b></span></td></tr><tr><td class=\"quote\">",$text);
	
	$text = str_replace("[/quote]","</td></tr></table>",$text);
	
	
	
	// Code borrowed from phpBB 
	// It's unmodified besides replacing the $bbcode_tpl variables with what's in the subsilver bbcode.tpl page... if it's a violation please tell me i will be more than happy to fix it.
	
	// Patterns and replacements for URL and email tags..
	$patterns = array();
	$replacements = array();

	// [img]image_url_here[/img] code..
	// This one gets first-passed..
	$patterns[] = "#\[img\](.*?)\[/img\]#si";
	$replacements[] = "<img src=\"\\1\" border=\"0\" />";

	// matches a [url]xxxx://www.phpbb.com[/url] code..
	$patterns[] = "#\[url\]([\w]+?://[^ \"\n\r\t<]*?)\[/url\]#is";
	$replacements[] = "<a href=\"\\1\">\\1</a>";

	// [url]www.phpbb.com[/url] code.. (no xxxx:// prefix).
	$patterns[] = "#\[url\]((www|ftp)\.[^ \"\n\r\t<]*?)\[/url\]#is";
	$replacements[] = "<a href=\"http://\\1\">\\1</a>";

	// [url=xxxx://www.phpbb.com]phpBB[/url] code..
	$patterns[] = "#\[url=([\w]+?://[^ \"\n\r\t<]*?)\](.*?)\[/url\]#is";
	$replacements[] = "<a href=\"\\1\">\\2</a>";

	// [url=www.phpbb.com]phpBB[/url] code.. (no xxxx:// prefix).
	$patterns[] = "#\[url=((www|ftp)\.[^ \"\n\r\t<]*?)\](.*?)\[/url\]#is";
	$replacements[] = "<a href=\"http://\\1\">\\3</a>";

	// [email]user@domain.tld[/email] code..
	$patterns[] = "#\[email\]([a-z0-9&\-_.]+?@[\w\-]+\.([\w\-\.]+\.)?[\w]+)\[/email\]#si";
	$replacements[] = "<a href=\"mailto:\\1\">\\1</A>";

	$text = preg_replace($patterns, $replacements, $text);
	
	// Thanks guys
	
	// And Changing Size and color
	$text = preg_replace("/\[size=([1-9]?[0-9])\]/si", "<span style=\"font-size: \\1px; line-height: normal\">", $text);
	$text = str_replace("[/size]","</span>", $text);
	$text = preg_replace("/\[color=(\#[0-9A-F]{6})\]/si", "<span style=\"color: \\1\">", $text);
	$text = str_replace("[/color]", "</span>", $text);
	
	// Now what about lists...
	$text = str_replace("[list]","<table border=0 cellpadding=0 cellspacing=0><tr><td width=\"15px\">&nbsp;</td><td class=\"postbody\">",$text);
	$text = str_replace("[/list]","</td></tr></table>",$text);
	// Somewhat of a list
	
	// What about quotes...
	
	$text = nl2br($text);
	//$text = htmlentities($text);
	//$text = htmlspecialchars($text);
		
	$text = ltrim($text," ");
		
	// All done
	// I would really like to thank phpbb guys for their help.
	// let's send it back
	return $text;
}

// Smilie Parse w00t
function parse_smilies($text){
	$smilies = generate_smilies();
	
	foreach($smilies as $name => $code){
		$text = str_replace($code,"<img alt=\"$code\" src=\"smilies/$name\">",$text);
	}
	return $text;
}
// Generates smilies for above parser
function generate_smilies(){
	$query = "SELECT * FROM smilies";
	$result = @mysql_query($query);

	while(list($id,$code,$name,$description) = mysql_fetch_row($result)){
		$smilies[$name] = $code;
	}
	return $smilies;
}

// Date Functions
function axSlashedDate($date)
{
	$date1 = substr($date, 4, 2); $date1 = ltrim($date1,"0"); $date2 = substr($date, 6, 2); $date2 = ltrim($date2,"0"); $date3 = substr($date, 0, 4);
	$ndate = $date1."/".$date2."/".$date3;
	return $ndate;
}
function axEncodeDate($month, $day, $year)
{
	if(strlen($month) < 2)
	{
		$month = "0".$month;
	}
	if(strlen($day) < 2)
	{
		$day = "0".$day;
	}
	$ndate = $year.$month.$day;
	return $ndate;
}
function axGenDBDate()
{
	return axEncodeDate(date("m"),date("d"),date("Y"));
}

?>