<?php

/**
* @author Tsixm Xephor
* @copyright 2005 Aklix Networks
* @link http://www.aklix.com/
* @package AxNet Developer's CMS
* @version 0.1.1
**/

/* ***************************************************************************
* This file is part of AxNet Developer's CMS.
* 
* AxNet Developer's CMS is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* 
* AxNet Developer's CMS is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with AxNet Developer's CMS; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*************************************************************************** */

if(AX_ADMIN != 1)
{
	axError($lang['critical_error'],$lang['axadmin_zero_message']);
}

function aXfaq()
{
	GLOBAL $req;
	
	if($req['mode'] == "add")
	{
		return aXfaq_form("new");
	}
	elseif($req['mode'] == "modify")
	{
		return aXfaq_form($req['qid']);
	}
	elseif($req['mode'] == "save")
	{
		return aXfaq_save($req['qid']);
	}
	elseif($req['mode'] == "delete")
	{
		return aXfaq_delete($req['qid']);
	}
	else
	{
		return aXfaq_list();
	}
}

function aXfaq_info()
{
	GLOBAL $lang;
	GLOBAL $req;
	
	if($req['mode'] == "add")
	{
		$toReturn['page_title'] = $lang['Add FAQ'];
	}
	elseif($req['mode'] == "modify")
	{
		$toReturn['page_title'] = $lang['modify_faq']." ".$req['nid'];
	}
	elseif($req['mode'] == "save")
	{
		$toReturn['page_title'] = $lang['saving_faq'];
	}
	elseif($req['mode'] == "delete")
	{
		$toReturn['page_title'] = $lang['delete_faq'];
	}
	else
	{
		$toReturn['page_title'] = $lang['faq'];
	}
	
	return $toReturn;
}

function aXfaq_list()
{
	GLOBAL $lang;
	GLOBAL $aXconf;
	GLOBAL $req;
	
	$funcTemplate = new Smarty;
	
	$query = "SELECT * FROM module_faq ORDER BY q_id ASC";
	
	$result = mysql_query($query);
	
	if(mysql_num_rows($result) == 0)
	{
		axError($lang['no_faq'],$lang['no_faq_message']);
	}
	
	$i = 1;
	while(list($id, $question, $answer) = mysql_fetch_row($result))
	{	
		$question = axParse($question,1);
		$faq[] = array("question" => $question, "u_delete" => "admin.php?module=faq&mode=delete&qid=".$id, "u_edit" => "admin.php?module=faq&mode=modify&qid=".$id,"i" => $i);
		if($i==1){$i=2;}
		else{$i=1;}
	}
	
	$funcTemplate->assign("faq",$faq);
	$funcTemplate->assign("l_faq",$lang['freq_ques']);
	$funcTemplate->assign("l_edit",$lang['edit']);
	$funcTemplate->assign("l_delete",$lang['delete']);
	
	$toReturn = $funcTemplate->fetch($aXconf['templateDir']."faq_list.tpl");
	return $toReturn;
}

function aXfaq_delete($qid)
{
	GLOBAL $lang;
	GLOBAL $req;
	GLOBAL $aXconf;
	
	if(ereg("([^0-9])",$qid))
		axError($lang['invalid_faq_id'], $lang['invalid_faq_id_message']);
	
	$funcTemplate = new Smarty;
	
	if($req['confirmed'] == "yes")
	{
		$query = "SELECT * FROM module_faq WHERE q_id = $qid";
		$result = mysql_query($query);
		
		if(!$result)
		{
			axError($lang['error'],$lang['faq_no_exist']);
		}
		if(mysql_num_rows($result) != 1)
		{
			axError($lang['error'],$lang['faq_no_exist']);
		}		
		
		$query = "DELETE FROM module_faq WHERE q_id = $qid";
		$result = mysql_query($query);
			
		
		if(!$result)
		{
			axError($lang['error'],$lang['problem_faq_removal']);
		}
		if((mysql_affected_rows() == 0) || (mysql_affected_rows() == -1))
		{
			axError($lang['error'],$lang['problem_faq_removal']);
		}
		
		axError($lang['success'],$lang['faq_deleted']);
	}
	else
	{
		axError($lang['confirm'],$lang['confirm_faq_delete']."<br /><a href=\"admin.php?module=faq&mode=delete&qid=$qid&confirmed=yes\" class=\"postbody\">".$lang['yes']."</a>&nbsp;&nbsp;&nbsp;<a href=\"admin.php?module=faq\" class=\"postbody\">".$lang['no']."</a>");
	}
}

function aXfaq_form($qid)
{
	GLOBAL $lang;
	GLOBAL $req;
	GLOBAL $aXconf;
	GLOBAL $user_data;
	
	if($qid == "new")
	{
		$answer = "";
		$question = "";
	}
	else
	{
		$tfaq = aXfaq_fetch($qid);
		$answer = axParse($tfaq['q_answer'],1);
		$question = axParse($tfaq['q_question'],1);
	}
	
	
	$funcTemplate = new Smarty;
	
	$funcTemplate->assign("l_add_faq",$lang['add_faq']);
	$funcTemplate->assign("l_question",$lang['question']);
	$funcTemplate->assign("l_answer",$lang['answer']);
	$funcTemplate->assign("l_submit",$lang['submit']);
	
	$funcTemplate->assign("f_question","question");
	$funcTemplate->assign("f_answer","answer");
	$funcTemplate->assign("v_answer",$answer);
	$funcTemplate->assign("v_question",$question);	
		
	$funcTemplate->assign("form_action","admin.php?module=faq&mode=save&qid=".$qid);
	
	$toReturn = $funcTemplate->fetch($aXconf['templateDir']."faq_form.tpl");
	return $toReturn;
}

function aXfaq_save($qid)
{
	GLOBAL $lang;
	GLOBAL $rpost;
	GLOBAL $aXconf;
	
	if($qid != "new")
	{
	 if(!ereg("([^0-9])",$qid))
	 {
	 	$tfaq = aXfaq_fetch($qid);
	 }
	 else
	 {
	 	axError($lang['critical_error'],$lang['invalid_faq_id_message']);
	 }
	
	 $question = axClean($rpost['question']);
		
	 $q_code = "";
	 if($question != $tfaq['q_question'])
	 {
	 	$q_code = "q_question = '$question'";
	 }
	 	
	 	
     $a_code = "";
	 $answer = axClean($rpost['answer']);
	 if($answer != $tfaq['q_answer'])
	 {
	 	$a_code = "q_answer = '$answer'";
		if($q_code != "")
		{
			$q_code .= ", ";
		}
	 }
		
		
	 if(($q_code == "")&&($a_code == ""))
	 {
	 	axError($lang['success'],$lang['faq_updated']);
	 }
		
	 $query = "UPDATE module_faq SET ".$q_code.$a_code." WHERE q_id = '$qid' LIMIT 1";
	}
	else
	{
		$question = axClean($rpost['question']);
		$answer = axClean($rpost['answer']);
		$query = "INSERT INTO module_faq SET q_question = '$question', q_answer = '$answer'";
	}
	$result = mysql_query($query);
	if(!$result)
	{
		axError($lang['critical_error'],$lang['faq_not_updated']);
	}
	elseif(mysql_affected_rows() < -1)
	{
		axError($lang['critical_error'],$lang['faq_negative_update']);
	}
	elseif(mysql_affected_rows() == -1)
	{
		axError($lang['critical_error'],$lang['faq_query_error']);
	}
	elseif(mysql_affected_rows() == 0)
	{
		axError($lang['critical_error'],$lang['faq_not_updated']);
	}
	elseif(mysql_affected_rows() > 1)
	{
		axError($lang['critical_error'],$lang['faq_multiple_update']);
	}
	
	axError($lang['success'],$lang['faq_updated']);
}

function aXfaq_fetch($qid)
{
	GLOBAL $lang;

	$query = "SELECT * FROM module_faq WHERE q_id = ".$qid;
	$result = mysql_query($query);
	if(!$result)
	{
		axError($lang['critical_error'],$lang['invalid_faq_id_message']);
	}
	elseif(mysql_num_rows($result) != 1)
	{
		axError($lang['critical_error'],$lang['invalid_faq_id_message']);
	}
	return mysql_fetch_assoc($result);
}

?>