<?php

/**
* @author Tsixm Xephor
* @copyright 2005 Aklix Networks
* @link http://www.aklix.com/
* @package AxNet Developer's CMS
* @version 0.1.1
**/

/* ***************************************************************************
* This file is part of AxNet Developer's CMS.
* 
* AxNet Developer's CMS is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* 
* AxNet Developer's CMS is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with AxNet Developer's CMS; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*************************************************************************** */

if(AX_ADMIN != 1)
{
	axError($lang['critical_error'],$lang['axadmin_zero_message']);
}

function aXnews()
{
	GLOBAL $req;
	
	if($req['mode'] == "add")
	{
		return aXnews_form();
	}
	elseif($req['mode'] == "modify")
	{
		return aXnews_form($req['nid']);
	}
	elseif($req['mode'] == "save")
	{
		return aXnews_save($req['nid']);
	}
	elseif($req['mode'] == "delete")
	{
		return aXnews_delete($req['nid']);
	}
	else
	{
		return aXnews_list();
	}
}

function aXnews_info()
{
	GLOBAL $lang;
	GLOBAL $req;
	if($req['mode'] == "add")
	{
		$toReturn['page_title'] = $lang['add_news_item'];
	}
	elseif($req['mode'] == "modify")
	{
		$toReturn['page_title'] = $lang['modify_news_item']." ".$req['nid'];
	}
	elseif($req['mode'] == "save")
	{
		$toReturn['page_title'] = $lang['saving_news_item'];
	}
	elseif($req['mode'] == "delete")
	{
		$toReturn['page_title'] = $lang['delete_news'];
	}
	else
	{
		$toReturn['page_title'] = $lang['news'];
	}
	
	return $toReturn;
}

function aXnews_list()
{
	GLOBAL $lang;
	GLOBAL $aXconf;
	$funcTemplate = new Smarty;
	
	$query = "SELECT * FROM news ORDER BY n_id DESC";
	$result = mysql_query($query);
	
	if(mysql_num_rows($result) == 0)
	{
		axError($lang['no_news'],$lang['no_news_message']);
	}
	
	while(list($id, $title, $author, $date, $body) = mysql_fetch_row($result))
	{	
		$date = axSlashedDate($date);
		$title = axParse($title,1);
		$body = axParse($body,1);
		
		$tplconf = axConfigParse($aXconf['templateDir'].$aXconf['currentTheme'].".conf");
		if(strlen($body) > $tplconf['news_admin_trim'])
		{
			$body = substr($body,0,256);
			$body .= $tplconf['news_truncate_tail'];
		}
	
		$author_data = aXget_user_data($author);
		$phpBBid = $author_data['u_phpbbid'];
		$author = $author_data['u_name'];
		
		$news[] = array("date" => $date, "title" => $title, "body" => $body, "author" => $author, "phpbbid" => $phpBBid,"u_delete" => "admin.php?module=news&mode=delete&nid=".$id, "u_edit" => "admin.php?module=news&mode=modify&nid=".$id);		
	}
	
	$funcTemplate->assign("news",$news);
	$funcTemplate->assign("l_news",$lang['news']);
	$funcTemplate->assign("l_by",$lang['by']);
	$funcTemplate->assign("l_date",$lang['date_posted']);
	$funcTemplate->assign("l_edit",$lang['edit']);
	$funcTemplate->assign("l_delete",$lang['delete']);
	$funcTemplate->assign("l_author",$lang['author']);
	
	$toReturn = $funcTemplate->fetch($aXconf['templateDir']."news_admin.tpl");
	return $toReturn;
}

function aXnews_form($nid = 0,$previewed = 0,$errors = "")
{
	GLOBAL $lang;
	GLOBAL $aXconf;
	GLOBAL $rpost;
	GLOBAL $user_data;
	
	$funcTemplate = new Smarty;
	
	$query = "SELECT * FROM smilies";
	$result = mysql_query($query);
	
	if(mysql_num_rows($result) == 0)
	{
		axError($lang['critical_error'],$lang['smilie_error_message']);
	}
	
	while(list($id, $code, $name, $description) = mysql_fetch_row($result))
	{		
		$smilies[] = array("code" => $code, "text" => $description, "src" => "./smilies/".$name);		
	}
	
	$funcTemplate->assign("smilies",$smilies);
	
	$funcTemplate->assign("table_name",$lang['add_news_item']);
	
	$funcTemplate->assign("l_title",$lang['title']);
	$funcTemplate->assign("l_message",$lang['message']);
	$funcTemplate->assign("l_smilies",$lang['smilies']);
	$funcTemplate->assign("l_B",$lang['b_bold']);
	$funcTemplate->assign("l_i",$lang['i_italics']);
	$funcTemplate->assign("l_u",$lang['u_underline']);
	$funcTemplate->assign("l_quote",$lang['quote']);
	$funcTemplate->assign("l_code",$lang['code']);
	$funcTemplate->assign("l_list",$lang['list']);
	$funcTemplate->assign("l_img",$lang['img_image']);
	$funcTemplate->assign("l_url",$lang['url']);
	$funcTemplate->assign("l_fontcolor",$lang['font_color']);
	$funcTemplate->assign("l_default",$lang['default']);
	
	// Colorful Array
		$colors[] = array("v" => "darkred", "t" => $lang['darkred']);
		$colors[] = array("v" => "red", "t" => $lang['red']);
		$colors[] = array("v" => "orange", "t" => $lang['orange']);
		$colors[] = array("v" => "brown", "t" => $lang['brown']);
		$colors[] = array("v" => "yellow", "t" => $lang['yellow']);
		$colors[] = array("v" => "green", "t" => $lang['green']);
		$colors[] = array("v" => "olive", "t" => $lang['olive']);
		$colors[] = array("v" => "cyan", "t" => $lang['cyan']);
		$colors[] = array("v" => "blue", "t" => $lang['blue']);
		$colors[] = array("v" => "darkblue", "t" => $lang['darkblue']);
		$colors[] = array("v" => "indigo", "t" => $lang['indigo']);
		$colors[] = array("v" => "violet", "t" => $lang['violet']);
		$colors[] = array("v" => "white", "t" => $lang['white']);
		$colors[] = array("v" => "black", "t" => $lang['black']);
	// End Array
	
	$funcTemplate->assign("l_fontsize",$lang['font_size']);
	
	// Size Array
		$sizes[] = array("v" => "7", "t" => $lang['stiny']);
		$sizes[] = array("v" => "9", "t" => $lang['ssmall']);
		$sizes[] = array("v" => "12", "t" => $lang['snormal']);
		$sizes[] = array("v" => "18", "t" => $lang['slarge']);
		$sizes[] = array("v" => "24", "t" => $lang['shuge']);
	// End Array
	
	$funcTemplate->assign("font_c",$colors);
	$funcTemplate->assign("font_s",$sizes);
	
	$funcTemplate->assign("l_closetags",$lang['closetags']);
	$funcTemplate->assign("l_options",$lang['options']);
	
	$funcTemplate->assign("l_preview",$lang['Preview']);
	$funcTemplate->assign("l_submit",$lang['Post']);
	
	$funcTemplate->assign("f_message","message");  // CANNOT CHANGE
	$funcTemplate->assign("f_title","subject");	   // CANNOT CHANGE
	
	$funcTemplate->assign("f_submit","post");
	$funcTemplate->assign("f_poster","poster");
	
	$funcTemplate->assign("f_frontpage","frontpage");
	$funcTemplate->assign("v_frontpage","yes");
	$funcTemplate->assign("l_frontpage",$lang['add_frontpage']);
	
	$funcTemplate->assign("javascript","<script type=\"text/javascript\" language=\"javascript\" src=\"./lang/".$aXconf['default_language']."/bbcode_script.js\"");
	
	$funcTemplate->assign("v_helpline",$lang['helpline_message']);
	$funcTemplate->assign("v_errors",$errors);
	
	$toReturn = "";
	if($nid == 0)
	{
		$funcTemplate->assign("form_action","admin.php?module=news&mode=save&nid=new");
		
		if($previewed == 1)
		{
			$funcTemplate->assign("v_title",$rpost['subject']);
			$funcTemplate->assign("v_message",$rpost['message']);
			$funcTemplate->assign("v_poster","0");
			
			if($rpost['frontpage'] == "yes")
			{
				$funcTemplate->assign("c_frontpage","checked=\"checked\"");
			}
		}
		else
		{
			$funcTemplate->assign("c_frontpage","checked=\"checked\"");
		}
	}
	elseif($previewed == 1)
	{
		$funcTemplate->assign("v_title",$rpost['subject']);
		$funcTemplate->assign("v_message",$rpost['message']);
		$funcTemplate->assign("v_poster",$rpost['poster']);
		
		if($rpost['frontpage'] == "yes")
		{
			$funcTemplate->assign("c_frontpage","checked=\"checked\"");
		}
		
		if($rpost['poster'] == 0)
		{
			$funcTemplate->assign("form_action","admin.php?module=news&mode=save&nid=new");
			$rpost['poster'] = $user_data['u_id'];
		}
		else
		{
			$funcTemplate->assign("form_action","admin.php?module=news&mode=save&nid=".$nid);
		}
		$toReturn .= aXnews_preview($rpost['subject'],$rpost['message'],$rpost['poster']);
	}
	else
	{
		$query = "SELECT * FROM news WHERE n_id = ".$nid;
		$result = mysql_query($query);
		
		if(!$result){
			axError($lang['error'],$lang['news_no_exist']);
		}
		elseif(mysql_num_rows($result) != 1)
		{
			axError($lang['error'],$lang['news_no_exist']);
		}
		
		list($id, $title, $author, $date, $body,$frontpage) = mysql_fetch_row($result);
		$title = axParse($title,1);
		$body = axParse($body,1);
		
		if($frontpage == 1)
		{
			$funcTemplate->assign("c_frontpage","checked=\"checked\"");
		}
		
		$funcTemplate->assign("form_action","admin.php?module=news&mode=save&nid=".$nid);
		$funcTemplate->assign("v_title",$title);
		$funcTemplate->assign("v_message",$body);
		$funcTemplate->assign("v_poster",$author);
	}
	
	$toReturn .= $funcTemplate->fetch($aXconf['templateDir']."news_admin_add.tpl");
	return $toReturn;
}

function aXnews_save($nid)
{
	GLOBAL $rpost;
	GLOBAL $lang;
	GLOBAL $user_data;
	
	if($nid == "new")
	{
		$nid = 0;
	}
	
	if($rpost['post'] == $lang['Preview'])
	{
		$errors = "";
		
		if($rpost['subject'] == "")
			$errors .= $lang['news_title_no_blank'];
		
		if($rpost['message'] == "")
			$errors .= $lang['news_message_no_blank'];
		
		return aXnews_form($nid,1,$errors);
	}
	elseif($rpost['post'] == $lang['Post'])
	{		
		$errors = "";
		
		if($rpost['subject'] == "")
			$errors .= $lang['news_title_no_blank'];
		
		if($rpost['message'] == "")
			$errors .= $lang['news_message_no_blank'];
		
		if($errors != "")
		{
			return aXnews_form($nid,1,$errors);
		}
			
		$title = axClean($rpost['subject']);
		$body = axClean($rpost['message']);
		
		if($nid == 0)
		{
			$author = $user_data['u_id'];
			$date = axGenDBDate();
			if($rpost['frontpage'] == "yes")
			{
				$frontpage = 1;
			}
			else
			{
				$frontpage = 0;
			}
			
			$query = "INSERT INTO news SET n_title = '$title',n_author = $author, n_date = '$date', n_body = '$body', n_frontpage = $frontpage";
		}
		else
		{
			$query = "SELECT * FROM news WHERE n_id = '$nid'";
			$result= mysql_query($query);
			$body_db = mysql_result($result,0,"n_body");
			$title_db = mysql_result($result,0,"n_title");
			$fp_db = mysql_result($result,0,"n_frontpage");
			
			$title_code = "";
			if($title != $title_db)
			{
				$title_code = "n_title = '$title'";
			}
			
			$body_code = "";
			if($body != $body_db)
			{
				$body_code = "n_body = '$body'";
				if($title_code != "")
				{
					$title_code .= ", ";
				}
			}
			
			if($rpost['frontpage'] == "yes")
			{
				$frontpage = 1;
			}
			else
			{
				$frontpage = 0;
			}
			
			$fp_code = "";
			if($fp_db != $frontpage)
			{
				if(($body_code != "") || ($title_code != ""))
				{
					$fp_code = ", ";
				}	
				$fp_code .= "n_frontpage = $frontpage";
			}
			
			if(($body_code == "")&&($title_code == "")&&($fp_code == ""))
			{
				axError($lang['news_saved'],$lang['news_saved_message']);
			}
			
			$query = "UPDATE news SET ".$title_code.$body_code.$fp_code." WHERE n_id = '$nid' LIMIT 1";
		}
		$result = mysql_query($query);
		if(!$result)
		{
			axError($lang['critical_error'],$lang['news_save_error1']);
		}
		elseif(mysql_affected_rows() < -1)
		{
			axError($lang['critical_error'],$lang['news_save_error3']);
		}
		elseif(mysql_affected_rows() == -1)
		{
			axError($lang['critical_error'],$lang['news_save_error2']);
		}
		elseif(mysql_affected_rows() == 0)
		{
			axError($lang['critical_error'],$lang['news_save_error4']);
		}
		elseif(mysql_affected_rows() > 1)
		{
			axError($lang['critical_error'],$lang['news_save_error5']);
		}
		else
		{
			axError($lang['news_saved'],$lang['news_saved_message']);
		}
	}
	else
	{
		axError($lang['critical_error'],$lang['news_save_error6']);
	}
}

function aXnews_preview($title, $body, $author)
{
	GLOBAL $lang;
	GLOBAL $aXconf;

	$funcTemplate = new Smarty;
	
	$date = axSlashedDate(axGenDBDate());
	$title = axParse($title,1);
	$body = axParse($body);
	$author = aXget_user_name($author);
	
	$comment_count = "*";
	
	$funcTemplate->assign("title",$title);
	$funcTemplate->assign("date",$date);
	$funcTemplate->assign("body",$body);
	$funcTemplate->assign("author",$author);
	
	$funcTemplate->assign("l_author",$lang['author']);
	$funcTemplate->assign("l_date",$lang['date_posted']);
	$funcTemplate->assign("l_comments",$lang['comments']);
	
	$funcTemplate->assign("n_comments",$comment_count);
	$funcTemplate->assign("u_comments","#");
	
	$toReturn = $funcTemplate->fetch($aXconf['templateDir']."news.tpl");
	return $toReturn;
}

function aXnews_delete($nid)
{
	GLOBAL $lang;
	GLOBAL $req;
	GLOBAL $aXconf;
	
	if(ereg("([^0-9])",$req['uid']))
		axError($lang['error'], $lang['invalid_news_id']);
	
	$funcTemplate = new Smarty;
	
	if($req['confirmed'] == "yes")
	{
		$query = "SELECT * FROM news WHERE n_id = $nid";
		$result = mysql_query($query);
		
		if(!$result)
		{
			axError($lang['no_item'],$lang['news_no_exist']);
		}
		if(mysql_num_rows($result) != 1)
		{
			axError($lang['no_item'],$lang['news_no_exist']);
		}		
		
		$query = "SELECT * FROM news_comments WHERE c_parent = $nid";
		$result = mysql_query($query);
		
		if((!$result) || (mysql_num_rows($result) == 0)){
			
		}
		else
		{
			$query = "DELETE FROM news_comments WHERE c_parent = $nid";
			$result = mysql_query($query);
			
			if(!$result)
			{
				axError($lang['critical_error'],$lang['comment_removal_problem']);
			}
			if((mysql_affected_rows() == 0) || (mysql_affected_rows() == -1))
			{
				axError($lang['critical_error'],$lang['comment_removal_problem']);
			}
		}
		
		$query = "DELETE FROM news WHERE n_id = $nid";
		$result = mysql_query($query);
		
		if(!$result)
		{
			axError($lang['critical_error'],$lang['news_removal_problem']);
		}
		if((mysql_affected_rows() == 0) || (mysql_affected_rows() == -1))
		{
			axError($lang['critical_error'],$lang['news_removal_problem']);
		}
		
		axError($lang['success'],$lang['news_removal_success']);
	}
	else
	{
		axError($lang['confirm'],$lang['news_confirm']."<br /><a href=\"admin.php?module=news&mode=delete&nid=$nid&confirmed=yes\">".$lang['yes']."</a>&nbsp;&nbsp;&nbsp;<a href=\"admin.php?module=news\">".$lang['no']."</a>");
	}
}

?>