<?php

/**
* @author Tsixm Xephor
* @copyright 2005 Aklix Networks
* @link http://www.aklix.com/
* @package AxNet Developer's CMS
* @version 0.1.1
**/

/* ***************************************************************************
* This file is part of AxNet Developer's CMS.
* 
* AxNet Developer's CMS is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* 
* AxNet Developer's CMS is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with AxNet Developer's CMS; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*************************************************************************** */

if(AX_ADMIN != 1)
{
	axError($lang['critical_error'],$lang['axadmin_zero_message']);
}

include("modules/profile/lang/".$aXconf['default_language'].".php");

function aXprofile()
{
	GLOBAL $lang;
	GLOBAL $req;
	
	if($req['mode'] == "modify")
	{
		return aXprofile_form($req['uid']);
	}
	elseif($req['mode'] == "save")
	{
		return aXprofile_save($req['uid']);
	}
	elseif($req['mode'] == "delete")
	{
		return aXprofile_delete($req['uid']);
	}
	else
	{
		return aXprofile_list();
	}
}

function aXprofile_info()
{
	GLOBAL $lang;
	GLOBAL $req;
	
	if($req['mode'] == "modify")
	{
		$toReturn['page_title'] = $lang['modify_user']." ".$req['nid'];
	}
	elseif($req['mode'] == "save")
	{
		$toReturn['page_title'] = $lang['saving_user_data'];
	}
	elseif($req['mode'] == "delete")
	{
		$toReturn['page_title'] = $lang['delete_user'];
	}
	else
	{
		$toReturn['page_title'] = $lang['user_management'];
	}
	
	return $toReturn;
}

function aXprofile_list()
{
	GLOBAL $lang;
	GLOBAL $aXconf;
	GLOBAL $req;
	
	$funcTemplate = new Smarty;
	
	switch($req['sort'])
	{
		case "rank": 
			$query = "SELECT * FROM users ORDER BY u_rank DESC";
			break;
		case "name": 
			$query = "SELECT * FROM users ORDER BY u_name ASC";
			break;
		case "dname": 
			$query = "SELECT * FROM users ORDER BY u_name DESC";
			break;
		case "recent": 
			$query = "SELECT * FROM users ORDER BY u_id DESC";
			break;
		default:
			$query = "SELECT * FROM users ORDER BY u_id ASC";
	}
	$result = mysql_query($query);
	
	if(mysql_num_rows($result) == 0)
	{
		axError($lang['no_users'],$lang['no_users_m']);
	}
	
	$i = 1;
	while(list($id, $name, $password, $email, $rank, $theme) = mysql_fetch_row($result))
	{	
	  if($id != 1)
	  {
		$users[] = array("name" => $name, "email" => $email, "rank" => $rank, "u_delete" => "admin.php?module=profile&mode=delete&uid=".$id, "u_edit" => "admin.php?module=profile&mode=modify&uid=".$id,"i" => $i);
		if($i==1){$i=2;}
		else{$i=1;}
	  }
	}
	
	$funcTemplate->assign("user",$users);
	$funcTemplate->assign("l_users",$lang['users']);
	$funcTemplate->assign("l_email",$lang['email']);
	$funcTemplate->assign("l_edit",$lang['edit']);
	$funcTemplate->assign("l_delete",$lang['delete']);
	
	$toReturn = $funcTemplate->fetch($aXconf['templateDir']."user_admin.tpl");
	return $toReturn;
}

function aXprofile_delete($uid)
{
	GLOBAL $lang;
	GLOBAL $req;
	GLOBAL $aXconf;
	
	if(ereg("([^0-9])",$uid))
		axError($lang['invalid_user_id'], $lang['invalid_user_id_m']);
	
	$funcTemplate = new Smarty;
	
	if($req['confirmed'] == "yes")
	{
		$query = "SELECT * FROM users WHERE u_id = $uid";
		$result = mysql_query($query);
		
		if(!$result)
		{
			axError("No User","User Does Not Exist!");
		}
		if(mysql_num_rows($result) != 1)
		{
			axError("No User","User Does Not Exist!");
		}		
		
		$query = "DELETE FROM users WHERE u_id = $uid";
		$result = mysql_query($query);
		
		// News Deletion
		$query = "SELECT * FROM news WHERE n_author = $uid";
		$result = mysql_query($query);
		
		if(!$result)
		{
		}
		elseif(mysql_num_rows($result) != 1)
		{
		}
		else
		{
			$query = "DELETE FROM news WHERE n_author = $uid";
			$result = mysql_query($query);
		}
		
		// Comment Deletion
		$query = "SELECT * FROM news_comments WHERE c_author = $uid";
		$result = mysql_query($query);
		
		if(!$result)
		{
		}
		elseif(mysql_num_rows($result) != 1)
		{
		}
		else
		{
			$query = "DELETE FROM news_comments WHERE c_author = $uid";
			$result = mysql_query($query);
		}		
		
		if(!$result)
		{
			axError($lang['error'],$lang['user_removal_error']);
		}
		if((mysql_affected_rows() == 0) || (mysql_affected_rows() == -1))
		{
			axError($lang['error'],$lang['user_removal_error']);
		}
		
		axError($lang['success'],$lang['user_removal_success']);
	}
	else
	{
		axError($lang['confirm'],$lang['user_del_conf']."<br /><a href=\"admin.php?module=profile&mode=delete&uid=$uid&confirmed=yes\">".$lang['yes']."</a>&nbsp;&nbsp;&nbsp;<a href=\"admin.php?module=profile\">".$lang['no']."</a>");
	}
}

function aXprofile_form($uid,$errors = "")
{
	GLOBAL $lang;
	GLOBAL $req;
	GLOBAL $aXconf;
	GLOBAL $user_data;
	
	$cudata = aXget_user_data($uid);
	
	$funcTemplate = new Smarty;
	
	if($errors != "")
	{
		$funcTemplate->assign("e_show","1");
		$funcTemplate->assign("e_body",$errors);
	}
	else
	{
		$funcTemplate->assign("e_show","0");
		$funcTemplate->assign("e_body","");
	}
	
	$funcTemplate->assign("s_admin","1");
	
	$funcTemplate->assign("l_username",$lang['username']);
	$funcTemplate->assign("l_registrationinfo",$lang['registration_info']);
	$funcTemplate->assign("l_email",$lang['email_address']);
	$funcTemplate->assign("l_currpass",$lang['curr_pass']);
	$funcTemplate->assign("l_newpass",$lang['new_pass']);
	$funcTemplate->assign("l_confpass",$lang['conf_pass']);
	$funcTemplate->assign("l_reset",$lang['reset']);
	$funcTemplate->assign("l_submit",$lang['submit']);
	$funcTemplate->assign("l_yes",$lang['yes']);
	$funcTemplate->assign("l_no",$lang['no']);
	$funcTemplate->assign("l_isadmin",$lang['isadmin']);
	
	$funcTemplate->assign("m_starred",$lang['m_starred']);
	$funcTemplate->assign("m_newpass",$lang['m_newpass']);
	
	$funcTemplate->assign("f_username","axusername");
	$funcTemplate->assign("f_confpass","axconf_password");
	$funcTemplate->assign("f_newpass","axnew_password");
	$funcTemplate->assign("f_email","axemail");
	$funcTemplate->assign("f_currpass","axcurr_password");
	$funcTemplate->assign("f_isadmin","axisadmin");
	
	if($cudata['u_rank'] == 1)
	{
		$funcTemplate->assign("v_isadmin_y","checked=\"checked\"");
		$funcTemplate->assign("v_isadmin_n","");
	}
	else
	{
		$funcTemplate->assign("v_isadmin_n","checked=\"checked\"");
		$funcTemplate->assign("v_isadmin_y","");
	}
	
	
	$funcTemplate->assign("v_username",$cudata['u_name']);
	$funcTemplate->assign("v_email",$cudata['u_email']);
	
	$funcTemplate->assign("form_action","admin.php?module=profile&mode=save&uid=".$uid);
	
	$toReturn = $funcTemplate->fetch($aXconf['templateDir']."user_regedit.tpl");
	return $toReturn;
}

function aXprofile_save($uid)
{
	GLOBAL $lang;
	GLOBAL $rpost;
	GLOBAL $aXconf;
	
	$tplconf = axConfigParse($aXconf['templateDir'].$aXconf['currentTheme'].".conf");
		$ext = $tplconf['error_separator'];
	
	$errors = "";
	if(($rpost['axusername'] == "") || ($rpost['axusername'] == " "))
	{
		$errors .= $lang['error_username']."$ext";
	}
	
	if(ereg("([^0-9])",$rpost['axisadmin']))
	{
		axError($lang['error'], $lang['error_isadmin']);
	}
	
	// Check Username for bad characters
		$unb = 0;
		if(strpos($rpost['axusername'],"'"))
			$unb = 1;
		if(strpos($rpost['axusername'],"\""))
			$unb = 1;
		if(strpos($rpost['axusername'],"\\"))
			$unb = 1;
		if(strpos($rpost['axusername'],"&"))
			$unb = 1;
		if(strpos($rpost['axusername'],"@"))
			$unb = 1;
		if(strpos($rpost['axusername'],"="))
			$unb = 1;
		if(strpos($rpost['axusername'],"+"))
			$unb = 1;
		if($unb == 1)
			$errors .= $lang['error_username']."$ext";
	// OK done.  If there are any other threat characters, add it
	
	if($rpost['axnew_password'] != "")
	{
		if(strlen($rpost['axnew_password']) < 7)
		{
			$errors .= $lang['error_passmin']."<br />";
		}
	}
	
	if(!axValidEmail($rpost['axemail']))
		$errors .= $lang['error_email']."$ext";
	
	if($errors != "")
	{
		$errors = rtrim($errors,$ext);
		return aXprofile_form($uid,$errors);
	}
	else
	{		
		$cuser = aXget_user_data($uid);
		
		$name_code = "";
		if($rpost['axusername'] != $cuser['u_name'])
		{
			$name_code = "u_name = '".$rpost['axusername']."'";
		}
		
		if($rpost['axnew_password'] != "")
		{
			$password = md5($rpost['axnew_password']);
			if($password != $cuser['u_password'])
			{
				$password_code = "u_password = '$password'";
				if($name_code != "")
				{
					$name_code .= ", ";
				}
			}
		}		
		
		$email_code = "";
		if($rpost['axemail'] != $cuser['u_email'])
		{
			$email_code = "u_email = '".$rpost['axemail']."'";
			if($password_code != "")
			{
				$password_code .= ", ";
			}
			elseif($name_code != "")
			{
				$name_code .=", ";
			}
		}
		
		$iad_code = "";
		if($rpost['axisadmin'] != $cuser['u_rank'])
		{
			$iad_code = "u_rank = '".$rpost['axisadmin']."'";
			if($email_code != "")
			{
				$email_code .= ", ";
			}
			elseif($password_code != "")
			{
				$password_code .= ", ";
			}
			elseif($name_code != "")
			{
				$name_code .=", ";
			}
		}
		
		if(($name_code == "")&&($password_code == "")&&($email_code == "")&&($iad_code == ""))
		{
			axError($lang['success'],$lang['success_save_m']);
		}
			
		$query = "UPDATE users SET ".$name_code.$password_code.$email_code.$iad_code." WHERE u_id = '$uid' LIMIT 1";
		$result = mysql_query($query);
		if(!$result)
		{
			axError($lang['critical_error'],$lang['error_update1']);
		}
		elseif(mysql_affected_rows() < -1)
		{
			axError($lang['critical_error'],$lang['error_update2']);
		}
		elseif(mysql_affected_rows() == -1)
		{
			axError($lang['critical_error'],$lang['error_update3']);
		}
		elseif(mysql_affected_rows() == 0)
		{
			axError($lang['critical_error'],$lang['error_update4']);
		}
		elseif(mysql_affected_rows() > 1)
		{
			axError($lang['critical_error'],$lang['error_update5']);
		}
		
		axError($lang['success'],$lang['success_save_m']);
	}
}

?>