<?php

/**
* @author Tsixm Xephor
* @copyright 2005 Aklix Networks
* @link http://www.aklix.com/
* @package AxNet Developer's CMS
* @version 0.1.1
**/

/* ***************************************************************************
* This file is part of AxNet Developer's CMS.
* 
* AxNet Developer's CMS is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* 
* AxNet Developer's CMS is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with AxNet Developer's CMS; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*************************************************************************** */

include("modules/profile/lang/".$aXconf['default_language'].".php");

function aXprofile()
{
	GLOBAL $req;
	GLOBAL $lang;
	
	if($req['mode'] == "register")
		$req['mode'] = "form";
	
	$rfunction = "aXprofile_".$req['mode'];
	return $rfunction();
}

function aXprofile_info()
{
	GLOBAL $req;
	GLOBAL $lang;
	
	if($req['mode'] == "logout")
	{
		$toReturn['page_title'] = $lang['logout'];
	}
	else
	{
		$toReturn['page_title'] = $lang['login'];
	}
	return $toReturn;
}

function aXprofile_login()
{
	GLOBAL $req;
	GLOBAL $rpost;
	GLOBAL $aXconf;
	GLOBAL $lang;
	
	$error = " ";
	$f_u_name = "";
	if($aXconf['loginRan'] == 1)
	{
		if($aXconf['loginValid'] == 1)
		{
			if($rpost['r_location'] == "nowhere")
			{
				$redrex = "";
			}
			else 
			{
				$redrex = "<script language='javascript'> window.setTimeout(\"window.location='".$aXconf['domain'].$rpost['r_location']."'\",3000);
				</script>"; 
			}
			
			$xdcmessage = sprintf($lang['loggingin_m'],$aXconf['site_name']);
			axError($lang['loggingin'],$xdcmessage.$redrex);
		} 
		else 
		{
			$error = $lang['invalid_uop'];
			$f_u_name = $rpost['u_name'];
			
			$req['rlocation'] = $rpost['r_location'];
		}
	}
	
	$tpl_login = new Smarty;
	
	$tpl_login->assign("l_username",$lang['username']);
	$tpl_login->assign("l_login",$lang['login']);
	$tpl_login->assign("form_action","index.php?module=profile&mode=login");
	$tpl_login->assign("l_password",$lang['password']);
	$tpl_login->assign("f_username","u_name");
	$tpl_login->assign("f_password","u_pass");
	$tpl_login->assign("u_register","index.php?module=profile&mode=register");
	$tpl_login->assign("l_register",$lang['register']);
	
	if($req['rlocation'] != "")
	{
		$req['rlocation'] = str_replace("_","&",$req['rlocation']);
		$tpl_login->assign("v_location",$req['rlocation']);
	}
	else
	{
		$tpl_login->assign("v_location","nowhere");
	}
	$tpl_login->assign("f_type","r_type");
	$tpl_login->assign("f_location","r_location");
	$tpl_login->assign("v_username",$f_u_name);
	$tpl_login->assign("errors",$error);
	$tpl_login->assign("l_remember",$lang['remember']);
	$tpl_login->assign("l_yes","Yes");
	$tpl_login->assign("l_no","No");
	$tpl_login->assign("f_remember","remember");
	$tpl_login->assign("v_remember_true","yes");
	$tpl_login->assign("v_remember_false","no");
	
	return $tpl_login->fetch($aXconf['templateDir']."login.tpl");
}

function aXprofile_logout()
{
	GLOBAL $req;
	GLOBAL $aXconf;
	GLOBAL $lang;
	
	$_SESSION['logged_on'] = 0;
	$_SESSION['u_id'] = 1;
	setcookie ("axCD", "", time() - 3600);
	
	$req['rlocation'] = str_replace("_","&",$req['rlocation']);
	
	if($req['rtype'] == "wiki")
	{
		$redrex = "<script language='javascript'> window.setTimeout(\"window.location='http://wiki.aklix.com".$req['rlocation']."'\",3000);
		</script>"; 
	} 
	else 
	{
		$redrex = "<script language='javascript'> window.setTimeout(\"window.location='".$aXconf['domain'].$req['rlocation']."'\",3000);
		</script>"; 
	}
	$xdcmessage = sprintf($lang['loggingout_m'],$aXconf['site_name']);
	axError($lang['loggingout'],$xdcmessage.$redrex);
}

function aXprofile_form($errors = "",$ax_username = "",$ax_email = "")
{
	GLOBAL $req;
	GLOBAL $aXconf;
	GLOBAL $user_data;
	GLOBAL $lang;
	
	if($user_data['u_id'] != 1)
	{
		axError($lang['error'],$lang['no_register_for_u']);
	}
	
	$funcTemplate = new Smarty;
	
	if($errors != "")
	{
		$funcTemplate->assign("e_show","1");
		$funcTemplate->assign("e_body",$errors);
	}
	else
	{
		$funcTemplate->assign("e_show","0");
		$funcTemplate->assign("e_body","");
	}
	
	$funcTemplate->assign("s_admin","0");
	
	$funcTemplate->assign("l_username",$lang['username']);
	$funcTemplate->assign("l_registrationinfo",$lang['registration_info']);
	$funcTemplate->assign("l_email",$lang['email_address']);
	$funcTemplate->assign("l_newpass",$lang['password']);
	$funcTemplate->assign("l_confpass",$lang['conf_pass']);
	$funcTemplate->assign("l_reset",$lang['reset']);
	$funcTemplate->assign("l_submit",$lang['submit']);
	$funcTemplate->assign("l_yes",$lang['yes']);
	$funcTemplate->assign("l_no",$lang['no']);
	
	$funcTemplate->assign("m_starred",$lang['m_starred']);
	$funcTemplate->assign("m_confpass",$lang['m_confpass']);
	$funcTemplate->assign("m_newpass",$lang['password_m']);
	
	$funcTemplate->assign("f_username","axusername");
	$funcTemplate->assign("f_confpass","axpassword_conf");
	$funcTemplate->assign("f_newpass","axpassword");
	$funcTemplate->assign("f_email","axemail");
	
	$funcTemplate->assign("v_username",$ax_username);
	$funcTemplate->assign("v_email",$ax_email);
	
	$funcTemplate->assign("form_action","index.php?module=profile&mode=save");
	
	$toReturn = $funcTemplate->fetch($aXconf['templateDir']."user_regedit.tpl");
	return $toReturn;
}

function aXprofile_save()
{
	GLOBAL $rpost;
	GLOBAL $aXconf;
	
	$tplconf = axConfigParse($aXconf['templateDir'].$aXconf['currentTheme'].".conf");
		$ext = $tplconf['error_separator'];
	
	$errors = "";
	if(($rpost['axusername'] == "") || ($rpost['axusername'] == " "))
	{
		$errors .= $lang['error_username']."$ext";
	}
	
	// Check Username for bad characters
		$unb = 0;
		if(strpos($rpost['axusername'],"'"))
			$unb = 1;
		if(strpos($rpost['axusername'],"\""))
			$unb = 1;
		if(strpos($rpost['axusername'],"\\"))
			$unb = 1;
		if(strpos($rpost['axusername'],"&"))
			$unb = 1;
		if(strpos($rpost['axusername'],"@"))
			$unb = 1;
		if(strpos($rpost['axusername'],"="))
			$unb = 1;
		if(strpos($rpost['axusername'],"+"))
			$unb = 1;
		if($unb == 1)
			$errors .= $lang['error_username']."$ext";
	// OK done.  If there are any other threat characters, add it
	
	if(aXuser_get_id($rpost['axusername']))
		$errors .= $lang['username_taken']."$ext";
	
	if($rpost['axpassword'] != "")
	{
		if(strlen($rpost['axpassword']) < 6)
		{
			$errors .= $lang['error_passmin']."$ext";
		}
	}
	else
	{
		$errors .= $lang['blankpass']."$ext";
	}
	
	if($rpost['axpassword'] != $rpost['axpassword_conf'])
		$errors .= $lang['unmatching_pass']."$ext";
	
	if(!axValidEmail($rpost['axemail']))
		$errors .= $lang['error_email']."$ext";
	
	if($errors != "")
	{
		$errors = rtrim($errors,$ext);
		return aXprofile_form($errors,$rpost['axusername'],$rpost['axemail']);
	}
	else
	{		
		$name_code = "u_name = '".$rpost['axusername']."', ";
		
		$password = md5($rpost['axpassword']);
		$password_code = "u_password = '$password', ";
		
		$email_code = "u_email = '".$rpost['axemail']."'";
			
		$query = "INSERT INTO users SET ".$name_code.$password_code.$email_code.", u_rank = 0, u_theme='".$aXconf['default_template']."'";
		$result = mysql_query($query);
		if(!$result)
		{
			axError($lang['critical_error'],$lang['error_update1']);
		}
		elseif(mysql_affected_rows() < -1)
		{
			axError($lang['critical_error'],$lang['error_update2']);
		}
		elseif(mysql_affected_rows() == -1)
		{
			axError($lang['critical_error'],$lang['error_update3']);
		}
		elseif(mysql_affected_rows() == 0)
		{
			axError($lang['critical_error'],$lang['error_update4']);
		}
		elseif(mysql_affected_rows() > 1)
		{
			axError($lang['critical_error'],$lang['error_update5']);
		}
		
		$mailtemp = new Smarty;
		$mailtemp->assign("username",$rpost['axusername']);
		$mailtemp->assign("password",$rpost['axpassword']);
		$mailtemp->assign("site_name",$aXconf['site_title']);
		$message = $mailtemp->fetch($aXconf['languageDir']."user_mail.tpl");
		$subject = sprintf($lang['register_subject'],$aXconf['site_name']);
		
		mail($rpost['axemail'],$subject,$message,"From:".$aXconf['site_email']."\r\n");
		
		axError($lang['success'],$lang['success_register_m']);
	}
}

?>